<?php
/*
  $Id: skipjack.php,v 1.00 2007/09/20 09:43:30 project3000 Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  class skipjack {
    var $code, $title, $description, $enabled;
    // true or false whether this is for a production account
    var $m_isProduction = true;
    // true or false whether this account uses advanced processing
    // (Paymentech, Nova, Comdata, Evertech, etc. use advanced processing)
    var $m_isAdvancedProcessing = false;
    // The Skipjack HTML serial number (required)
    var $m_serialNumber = null;
    // The Skipjack developer serial number (not always required for an authorization)
    var $m_devSerialNumber = null;
    

    var $POST_LOCATION_DEV = "https://developer.skipjackic.com/scripts/EvolvCC.dll?Authorize";
    var $POST_LOCATION_PROD = "https://www.skipjackic.com/scripts/EvolvCC.dll?Authorize";
    var $POST_LOCATION_ADVANCED_DEV = "https://developer.skipjackic.com/evolvcc/evolvcc.aspx?Authorize";
    var $POST_LOCATION_ADVANCED_PROD = "https://www.skipjackic.com/evolvcc/evolvcc.aspx?Authorize"; 

// class constructor
    function skipjack() {
      global $order;

      $this->code = 'skipjack';
      $this->title = MODULE_PAYMENT_SKIPJACK_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_SKIPJACK_TEXT_DESCRIPTION;
      $this->enabled = ((MODULE_PAYMENT_SKIPJACK_STATUS == 'True') ? true : false);
      $this->sort_order = MODULE_PAYMENT_SKIPJACK_SORT_ORDER;

      $this->setSerialNumber( MODULE_PAYMENT_SKIPJACK_SERIAL_NUMBER );
      $this->setDeveloperSerialNumber( MODULE_PAYMENT_SKIPJACK_DEVELOPER_SERIAL_NUMBER );
      $this->setIsProduction( ( MODULE_PAYMENT_SKIPJACK_IS_PRODUCTION == "Production" ) ? true : false );
      $this->setIsAdvanced( ( MODULE_PAYMENT_SKIPJACK_IS_ADVANCED == "Yes" ) ? true : false );

      if ((int)MODULE_PAYMENT_SKIPJACK_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_SKIPJACK_ORDER_STATUS_ID;
      }

      // set the posting location
      $this->setPostLocation();

      if (is_object($order)) $this->update_status();

    } // end constructor


   // skipjack class methods

   // Sets the serial number
   function setSerialNumber( $serialNumber )
   {
      $this->m_serialNumber = $serialNumber;

   } // setSerialNumber

   // Sets the developer serial number
   function setDeveloperSerialNumber( $devSerialNumber )
   {
      $this->m_devSerialNumber = $devSerialNumber;

   } // setDeveloperSerialNumber

   // true or false, indicate whether or not this is for a production account
   //
   function setIsProduction( $isProd )
   {
      $this->m_isProduction = $isProd;
   
   } // setIsProduction

   // true or false, indicate whether or not this is for an account that 
   // uses Skipjack's advanced processing
   function setIsAdvanced( $isAdv )
   {
      $this->m_isAdvancedProcessing = $isAdv;
   
   } // setIsAdvanced

   // Sets the post location based on the isProduction and isAdvanced flags
   function setPostLocation()
   {
      if ( $this->m_isProduction )
      {
         $this->form_action_url = ( $this->m_isAdvancedProcessing ) ? $this->POST_LOCATION_ADVANCED_PROD : $this->POST_LOCATION_PROD;
      } 
      else
      {
         $this->form_action_url = ( $this->m_isAdvancedProcessing ) ? $this->POST_LOCATION_ADVANCED_DEV : $this->POST_LOCATION_DEV;
      }

   } // setPostLocation

   /**
     * GenerateOrderNumber
     * Creates a unique order number of the correct length with the indicated front padding
     * @param $FrontPadString - the front padding
     * @param $len - desired length
     * @return the order number
     */
   function GenerateOrderNumber( $FrontPadString, $len )
   {
      $EndString = $FrontPadString;

      while ( strlen( $EndString ) < $len )
      {
         $EndString .= mt_rand( 0, 9 );
      }

      return $EndString;

   } // GenerateOrderNumber

   /*
    * Removes bad characters from a string
    *
    */
   function PurgeBadChars( $strInput )
   {
      $strReturn = $strInput;

      $strReturn = str_replace( "\"", "", $strReturn );      
      $strReturn = str_replace( "~", "", $strReturn );      
      $strReturn = str_replace( "`", "", $strReturn );      
      $strReturn = str_replace( "!", "", $strReturn );      
      $strReturn = str_replace( "@", "", $strReturn );      
      $strReturn = str_replace( "#", "", $strReturn );      
      $strReturn = str_replace( "$", "", $strReturn );      
      $strReturn = str_replace( "%", "", $strReturn );      
      $strReturn = str_replace( "^", "", $strReturn );      
      $strReturn = str_replace( "&", "", $strReturn );      
      $strReturn = str_replace( "*", "", $strReturn );      
      $strReturn = str_replace( "(", "", $strReturn );      
      $strReturn = str_replace( ")", "", $strReturn );      
      $strReturn = str_replace( "_", "", $strReturn );      
      $strReturn = str_replace( "-", "", $strReturn );      
      $strReturn = str_replace( "+", "", $strReturn );      
      $strReturn = str_replace( "=", "", $strReturn );      

      return $strReturn;
   } // PurgeBadChars

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_SKIPJACK_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SKIPJACK_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      $js = '  if (payment_value == "' . $this->code . '") {' . "\n" .
            '    var skipjack_cc_owner_firstname = document.checkout_payment.skipjack_cc_owner_firstname.value;' . "\n" .
            '    if (skipjack_cc_owner_firstname == "") {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_SKIPJACK_TEXT_JS_CC_OWNER_FIRSTNAME . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '    var skipjack_cc_owner_lastname = document.checkout_payment.skipjack_cc_owner_lastname.value;' . "\n" .
            '    if (skipjack_cc_owner_lastname == "") {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_SKIPJACK_TEXT_JS_CC_OWNER_LASTNAME . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '    var cc_number = document.checkout_payment.skipjack_cc_number.value;' . "\n" .
            '    if (cc_number == "" || cc_number.length < ' . CC_NUMBER_MIN_LENGTH . ') {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_SKIPJACK_TEXT_JS_CC_NUMBER . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '    var cc_cvv2 = document.checkout_payment.skipjack_cc_cvv2.value;' . "\n" .
            '    if (isNaN( cc_cvv2 ) || cc_cvv2.length < 3 || cc_cvv2.length > 4) {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_SKIPJACK_TEXT_JS_CC_CVV2 . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '  }' . "\n";

      return $js;
    }

    function selection() {
      global $order;

      for ($i=1; $i < 13; $i++) {
        $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
      }

      $today = getdate(); 
      for ($i=$today['year']; $i < $today['year']+10; $i++) {
        $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
      }

      $selection = array('id' => $this->code,
                         'module' => $this->title,
                         'fields' => array(array('title' => MODULE_PAYMENT_SKIPJACK_TEXT_REQUIRED_FIELD . MODULE_PAYMENT_SKIPJACK_TEXT_CREDIT_CARD_OWNER_FIRST_NAME,
                                                 'field' => tep_draw_input_field('skipjack_cc_owner_firstname', $order->billing['firstname'])),
                                           array('title' => MODULE_PAYMENT_SKIPJACK_TEXT_REQUIRED_FIELD . MODULE_PAYMENT_SKIPJACK_TEXT_CREDIT_CARD_OWNER_LAST_NAME,
                                                 'field' => tep_draw_input_field('skipjack_cc_owner_lastname', $order->billing['lastname'])),
                                           array('title' => MODULE_PAYMENT_SKIPJACK_TEXT_REQUIRED_FIELD . MODULE_PAYMENT_SKIPJACK_TEXT_CREDIT_CARD_NUMBER,
                                                 'field' => tep_draw_input_field('skipjack_cc_number')),
                                           array('title' => MODULE_PAYMENT_SKIPJACK_TEXT_REQUIRED_FIELD . MODULE_PAYMENT_SKIPJACK_TEXT_CREDIT_CARD_EXPIRES,
                                                 'field' => tep_draw_pull_down_menu('skipjack_cc_expires_month', $expires_month) . '&nbsp;' . tep_draw_pull_down_menu('skipjack_cc_expires_year', $expires_year)),
                                           array('title' => MODULE_PAYMENT_SKIPJACK_TEXT_REQUIRED_FIELD . MODULE_PAYMENT_SKIPJACK_TEXT_CREDIT_CARD_CVV2,
                                                 'field' => tep_draw_input_field('skipjack_cc_cvv2', '', 'size="4" maxlength="4"') . '&nbsp;<small>' . MODULE_PAYMENT_SKIPJACK_TEXT_CREDIT_CARD_CVV2_LOCATION . '</small>')));

      return $selection;
    }

    function pre_confirmation_check() {
      global $HTTP_POST_VARS;

      include(DIR_WS_CLASSES . 'cc_validation.php');

      $cc_validation = new cc_validation();
      $result = $cc_validation->validate($HTTP_POST_VARS['skipjack_cc_number'], $HTTP_POST_VARS['skipjack_cc_expires_month'], $HTTP_POST_VARS['skipjack_cc_expires_year']);

      $error = '';
      switch ($result) {
        case -1:
          $error = sprintf(TEXT_CCVAL_ERROR_UNKNOWN_CARD, substr($cc_validation->cc_number, 0, 4));
          break;
        case -2:
        case -3:
        case -4:
          $error = TEXT_CCVAL_ERROR_INVALID_DATE;
          break;
        case false:
          $error = TEXT_CCVAL_ERROR_INVALID_NUMBER;
          break;
      }

      if ( ($result == false) || ($result < 1) ) {
        $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) . '&skipjack_cc_owner_firstname=' . urlencode($HTTP_POST_VARS['skipjack_cc_owner_firstname']) . '&skipjack_cc_owner_lastname=' . urlencode($HTTP_POST_VARS['skipjack_cc_owner_lastname']) . '&skipjack_cc_expires_month=' . $HTTP_POST_VARS['skipjack_cc_expires_month'] . '&skipjack_cc_expires_year=' . $HTTP_POST_VARS['skipjack_cc_expires_year'];

        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }

      $this->cc_card_type = $cc_validation->cc_type;
      $this->cc_card_number = $cc_validation->cc_number;
      $this->cc_expiry_month = $cc_validation->cc_expiry_month;
      $this->cc_expiry_year = $cc_validation->cc_expiry_year;
    }

    function confirmation() {
      global $HTTP_POST_VARS;

      $confirmation = array('title' => $this->title . ': ' . $this->cc_card_type,
                            'fields' => array(array('title' => MODULE_PAYMENT_SKIPJACK_TEXT_CREDIT_CARD_OWNER,
                                                    'field' => $HTTP_POST_VARS['skipjack_cc_owner_firstname'] . ' ' . $HTTP_POST_VARS['skipjack_cc_owner_lastname']),
                                              array('title' => MODULE_PAYMENT_SKIPJACK_TEXT_CREDIT_CARD_NUMBER,
                                                    'field' => str_repeat('X', (strlen($this->cc_card_number) - 4)) . substr($this->cc_card_number, -4)),
                                              array('title' => MODULE_PAYMENT_SKIPJACK_TEXT_CREDIT_CARD_EXPIRES,
                                                    'field' => strftime('%B, %Y', mktime(0,0,0,$HTTP_POST_VARS['skipjack_cc_expires_month'], 1, '20' . $HTTP_POST_VARS['skipjack_cc_expires_year']) ) ),
                                              array('title' => MODULE_PAYMENT_SKIPJACK_TEXT_CREDIT_CARD_CVV2,
                                                    'field' => ( strlen( $HTTP_POST_VARS['skipjack_cc_cvv2'] ) > 0 ) ? "Supplied" : "Not Supplied")));

      return $confirmation;
    }


    function process_button() {
      global $HTTP_SERVER_VARS, $HTTP_POST_VARS, $order, $customer_id;

      // Billing Name cannot contain '&' and must be no more than 40 characters long
      $BillingName = substr( str_replace( "&", "and", $order->billing['firstname'] . ' ' . $order->billing['lastname'] ), 0, 40 );
      // Shipping Name cannot contain '&' and must be no more than 40 characters long
      $ShippingName = substr( str_replace( "&", "and", $order->delivery['firstname'] . ' ' . $order->delivery['lastname'] ), 0, 40 );

      $OrderString = "";      
      $i = 0;
      $Items = $order->products;

      for ( $i = 0; $i < sizeof($Items); $i++ )
      {
         $OrderString .= $this->PurgeBadChars( $Items[$i]["id"] );
         $OrderString .= "~";
         $OrderString .= $this->PurgeBadChars( $Items[$i]["name"] );
         $OrderString .= "~";
         $OrderString .= $Items[$i]["price"];
         $OrderString .= "~";
         $OrderString .= $Items[$i]["qty"];
         $OrderString .= "~";
         $OrderString .= "N";
         $OrderString .= "~||";

      } // iterate the products

      // add shipping
      $OrderString .= "SHIP";
      $OrderString .= "~";
      $OrderString .= "Shipping Amount";
      $OrderString .= "~";
      $OrderString .= number_format( $order->info['shipping_cost'], 2 );
      $OrderString .= "~";
      $OrderString .= "1";
      $OrderString .= "~";
      $OrderString .= "N";
      $OrderString .= "~||";

      // add tax
      $OrderString .= "TAX";
      $OrderString .= "~";
      $OrderString .= "Tax Amount";
      $OrderString .= "~";
      $OrderString .= number_format( $order->info['tax'], 2 );
      $OrderString .= "~";
      $OrderString .= "1";
      $OrderString .= "~";
      $OrderString .= "N";
      $OrderString .= "~||";


      $sequence = rand(1, 1000);
      $process_button_string = tep_draw_hidden_field('accountnumber', $this->cc_card_number) .
                               tep_draw_hidden_field('month', $this->cc_expiry_month) .
                               tep_draw_hidden_field('year', $this->cc_expiry_year) .
                               tep_draw_hidden_field('cvv2', $HTTP_POST_VARS['skipjack_cc_cvv2']) .
                               tep_draw_hidden_field('serialnumber', MODULE_PAYMENT_SKIPJACK_SERIAL_NUMBER) .
                               tep_draw_hidden_field('developerserialnumber', MODULE_PAYMENT_SKIPJACK_DEVELOPER_SERIAL_NUMBER) .
                               tep_draw_hidden_field('ordernumber', $this->GenerateOrderNumber( "SJosC", 22 ) ) .
                               tep_draw_hidden_field('orderstring', $OrderString ) .
                               tep_draw_hidden_field('transactionamount', number_format($order->info['total'], 2)) .
                               tep_draw_hidden_field('sjname', $BillingName) .
                               tep_draw_hidden_field('email', $order->customer['email_address']) .
                               tep_draw_hidden_field('streetaddress', $order->billing['street_address']) .
                               tep_draw_hidden_field('streetaddress2', $order->billing['suburb']) .
                               tep_draw_hidden_field('city', $order->billing['city']) .
                               tep_draw_hidden_field('state', $order->billing['state']) .
                               tep_draw_hidden_field('zipcode', $order->billing['postcode']) .
                               tep_draw_hidden_field('country', $order->customer['country']['iso_code_2']) .
                               tep_draw_hidden_field('shiptophone', $order->customer['telephone']) .
                               tep_draw_hidden_field('shiptoname', $ShippingName) .
                               tep_draw_hidden_field('shiptostreetaddress', $order->delivery['street_address']) .
                               tep_draw_hidden_field('shiptostreetaddress2', $order->delivery['suburb']) .
                               tep_draw_hidden_field('shiptocity', $order->delivery['city']) .
                               tep_draw_hidden_field('shiptostate', $order->delivery['state']) .
                               tep_draw_hidden_field('shiptozipcode', $order->delivery['postcode']) .
                               tep_draw_hidden_field('version', MODULE_PAYMENT_SKIPJACK_PLUGIN_VERSION ) .
                               tep_draw_hidden_field('shiptocountry', $order->delivery['country']['iso_code_2']);

      $process_button_string .= tep_draw_hidden_field(tep_session_name(), tep_session_id());

      return $process_button_string;
    }

    function before_process() 
    {
        global $HTTP_POST_VARS;

        if ($HTTP_POST_VARS['szIsApproved'] != '1') 
        {
            if(isset($HTTP_POST_VARS['szAuthorizationDeclinedMessage']) && $HTTP_POST_VARS['szAuthorizationDeclinedMessage']!='')
            {
                tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode($HTTP_POST_VARS['szAuthorizationDeclinedMessage']), 'SSL', true, false));
            }
            else
            {
                tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_SKIPJACK_TEXT_ERROR_MESSAGE), 'SSL', true, false));
            }
        }
    }

    function after_process() {
      return false;
    }

    function get_error() {
      global $HTTP_GET_VARS;

      $error = array('title' => MODULE_PAYMENT_SKIPJACK_TEXT_ERROR,
                     'error' => stripslashes(urldecode($HTTP_GET_VARS['error'])));

      return $error;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SKIPJACK_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Skipjack Financial Services, Inc. Module', 'MODULE_PAYMENT_SKIPJACK_STATUS', 'True', 'Do you want to accept Skipjack Financial Services, Inc. payments?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('HTML Serial Number', 'MODULE_PAYMENT_SKIPJACK_SERIAL_NUMBER', '', 'The unique identifier for your Skipjack account', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Developer Serial Number', 'MODULE_PAYMENT_SKIPJACK_DEVELOPER_SERIAL_NUMBER', '', 'An additional credential associated with your Skipjack account.  It is not usually required for authorization requests.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Production or Developer', 'MODULE_PAYMENT_SKIPJACK_IS_PRODUCTION', 'Yes', 'Indicates whether this is a production account or a developer account.', '6', '0', 'tep_cfg_select_option(array(\'Production\', \'Developer\'),', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Is Advanced Processing Account', 'MODULE_PAYMENT_SKIPJACK_IS_ADVANCED', 'No', 'Indicates whether or not your Skipjack account is configured for advanced payment processing ', '6', '0', 'tep_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_PAYMENT_SKIPJACK_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first. ', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_SKIPJACK_STATUS', 'MODULE_PAYMENT_SKIPJACK_SERIAL_NUMBER', 'MODULE_PAYMENT_SKIPJACK_DEVELOPER_SERIAL_NUMBER', 'MODULE_PAYMENT_SKIPJACK_IS_PRODUCTION', 'MODULE_PAYMENT_SKIPJACK_IS_ADVANCED','MODULE_PAYMENT_SKIPJACK_SORT_ORDER');
    }
  }
?>
